package philosophers;

public class Main {
	static private final String [] philos = { "Aristotle", "Boole", "Comte", "Decartes", "Einstein" };
	static private final int numPhilosophers = philos.length;
	
	public static void main(String args[]) {
		Philosopher [] philosophers = new Philosopher[numPhilosophers];
		Chopstick [] chopsticks = new Chopstick[numPhilosophers];
		
		for (int i = 0; i < numPhilosophers; i++) {
			chopsticks[i] = new Chopstick (i);
		}
		
		for (int i = 0; i < numPhilosophers; i++) {
			// philosophers[i] = new Philosopher (philos[i], chopsticks[i], chopsticks[(i + 1) % numPhilosophers]);
			// philosophers[i] = new OrderedPhilosopher (philos[i], chopsticks[i], chopsticks[(i + 1) % numPhilosophers]);
			philosophers[i] = new PolitePhilosopher (philos[i], chopsticks[i], chopsticks[(i + 1) % numPhilosophers]);
		}
		
		// Start all philsopher threads
		for (int i = 0; i < numPhilosophers; i++) {
			System.out.println("Starting philosopher: " + philosophers[i]);
			new Thread(philosophers[i]).start();
		}
	}
}
