package philosophers;

public class Philosopher implements Runnable {
	protected String name;
	protected Chopstick left;
	protected Chopstick right;
	
	public Philosopher(String p_name, Chopstick p_left, Chopstick p_right) {
		name = p_name;
		left = p_left;
		right = p_right;
	}
	
	public String toString() {
		return name;
	}
	
	protected void philosophize() {
		System.out.println (name + " ponders the meaning of threads.");
		try {
			Thread.sleep(1000);
		} catch (InterruptedException ie) { 
			;
		}
	}
	
	protected void eat() {
		System.out.println(name + " eats.  Yum Yum.");
		try {
			Thread.sleep(1000);
		} catch (InterruptedException ie) { 
			;
		}
	}
	
	public void run() {
		while (!left.take(this)) { 
			philosophize();
		}
		
		philosophize();
		
		while (!right.take(this)) {
			philosophize();
		}
		
		eat ();
		left.release();
		right.release();
		System.out.println(name + " is finished.");
	}
}
