package philosophers;

public class PolitePhilosopher extends Philosopher {
	public PolitePhilosopher(String name, Chopstick left, Chopstick right) {
		super(name, left, right);
	}
	
	public void run() {
		Chopstick first, second;
		if (left.getNumber() < right.getNumber()) {
			first = left;
			second = right;
		} else {
			first = right;
			second = left;
		}
		synchronized (first) {
			while (first.isHeld ()) {
				try {
					first.wait();
				} catch (InterruptedException e) {
					;
				}
			}
			first.take(this);
		}
		philosophize();
		
		synchronized (second) {
			while (second.isHeld()) {
				try {
					second.wait();
				} catch (InterruptedException e) {
					;
				}
			}
			second.take(this);
		}
	
		eat ();
		first.release();
		second.release();
		System.out.println(name + " is finished.");
	}
}
